hdu1087Super Jumping! Jumping! Jumping!

来源:互联网 发布:西安seo 编辑:程序博客网 时间:2024/05/16 03:26

Super Jumping! Jumping! Jumping!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 24974    Accepted Submission(s): 11034


Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
 

Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
 

Output
For each case, print the maximum according to rules, and one line one case.
 

Sample Input
3 1 3 24 1 2 3 44 3 3 2 10
 

Sample Output
4103
 
 

hdu1087  Super Jumping! Jumping! Jumping!
题意:有一个横向棋盘,比赛者从strat位置经过棋盘中一些点到达end位置,
但是走棋盘有一个特点就是后面一个必须比前面的大才可以走,因此就可以转换成
最大子序列问题;
题目类型:dp,最大子序列和问题

题解:用第一重循环从刚开始strat遍历到end,对于每一个遍历到的a[i],又从0开始遍历到i-1;
看当前j是否满足a[j]<a[i],如果是这样的话,说明当前的a[j]满足,继续向下搜索,用dp[j]表示
从开始到第j个当前序列的最大值,用sum=max(sum,dp[j]+a[i]);来计算加上a[i]与a[i]之间的最大值,
然后将dp[i]更新为sum,再用一个Max存储最大值,每进行一次第二重循环便更新Max一次。

 

#include<iostream>#include<cstdio>#include<cstdlib>#include<cstring>using namespace std;int dp[1001],a[1001];int max(int a,int b){return a>b?a:b;}int main(){int n,i,j;while(~scanf("%d",&n)&&n){memset(dp,0,sizeof(dp));for(i=0;i<n;i++)scanf("%d",&a[i]);int Max=0;dp[0]=0;for(i=0;i<n;i++){int sum=a[i];for(j=0;j<i;j++){if(a[i]>a[j])//当前值比a[i]小,构成上升序列{sum=max(sum,dp[j]+a[i]);}}dp[i]=sum;//更新dp[i],表示到当前i为止得到的和最大值Max=max(Max,dp[i]);}printf("%d\n",Max);}return 0;}


 

 


0 0
原创粉丝点击